#!/bin/sh
#
# Create IDE/SCSI hard drive devices /dev/hd* and /dev/sd* if not found.
#
TMP=/tmp
#
   if [ ! -d /dev ]; then
     mkdir /dev
   fi

find_dev() {
    echo $line | grep -q target0 && DEV=/dev/$1"da"
    echo $line | grep -q target1 && DEV=/dev/$1"db"
    echo $line | grep -q target2 && DEV=/dev/$1"dc"
    echo $line | grep -q target3 && DEV=/dev/$1"dd"
    echo $line | grep -q target4 && DEV=/dev/$1"de"
    echo $line | grep -q target5 && DEV=/dev/$1"df"
    echo $line | grep -q target6 && DEV=/dev/$1"dg"
    echo $line | grep -q target7 && DEV=/dev/$1"dh"
    echo $line | grep -q target8 && DEV=/dev/$1"di"
    echo $line | grep -q target9 && DEV=/dev/$1"dj"
    echo $line | grep -q target10 && DEV=/dev/$1"dk"
}

find_part() {
    echo $line | grep -q target0 && DEV=/dev/$1"da"$part
    echo $line | grep -q target1 && DEV=/dev/$1"db"$part
    echo $line | grep -q target2 && DEV=/dev/$1"dc"$part
    echo $line | grep -q target3 && DEV=/dev/$1"dd"$part
    echo $line | grep -q target4 && DEV=/dev/$1"de"$part
    echo $line | grep -q target5 && DEV=/dev/$1"df"$part
    echo $line | grep -q target6 && DEV=/dev/$1"dg"$part
    echo $line | grep -q target7 && DEV=/dev/$1"dh"$part
    echo $line | grep -q target8 && DEV=/dev/$1"di"$part
    echo $line | grep -q target9 && DEV=/dev/$1"dj"$part
    echo $line | grep -q target10 && DEV=/dev/$1"dk"$part
}

   if grep -q "/disc" /proc/partitions ; then
   grep "/disc" /proc/partitions | while read line
   do
   if echo $line | grep -q "ide/" ; then
     p=h
   elif echo $line | grep -q "scsi/" ; then
     p=s
   fi
    SMASHED_LINE=$line
    MAJOR=`echo $SMASHED_LINE | cut -f 1 -d ' '`
    MINOR=`echo $SMASHED_LINE | cut -f 2 -d ' '`
    DEVFS=`echo $SMASHED_LINE | cut -f 4 -d ' '`
    find_dev $p
    if [ ! -b $DEV ]; then
      mknod -m 660 $DEV b $MAJOR $MINOR
      chown root.disk $DEV 2>$TMP/null
    fi
    if [ ! -b /dev/$DEVFS ]; then
      mkdir -p `dirname /dev/$DEVFS`
      mknod -m 660 /dev/$DEVFS b $MAJOR $MINOR
      chown root.disk $DEVFS 2>$TMP/null
    fi
   done   
   grep "/part" /proc/partitions | while read line
   do
    if echo $line | grep -q "ide/" ; then
      p=h
    elif echo $line | grep -q "scsi/" ; then
      p=s
    fi
    SMASHED_LINE=$line
    MAJOR=`echo $SMASHED_LINE | cut -f 1 -d ' '`
    MINOR=`echo $SMASHED_LINE | cut -f 2 -d ' '`
    DEVFS=`echo $SMASHED_LINE | cut -f 4 -d ' '`
    part=`basename $DEVFS | cut -b 5-`
    find_part $p
    if [ ! -b $DEV ]; then
      mknod -m 660 $DEV b $MAJOR $MINOR
      chown root.disk $DEV 2>$TMP/null
    fi
    if [ ! -b /dev/$DEVFS ]; then
      mkdir -p `dirname /dev/$DEVFS`
      mknod -m 660 /dev/$DEVFS b $MAJOR $MINOR
      chown root.disk $DEVFS 2>$TMP/null
    fi
    done
  else
    grep "^ " /proc/partitions | while read line ; do
    SMASHED_LINE=$line
    MAJOR=`echo $SMASHED_LINE | cut -f 1 -d ' '`
    MINOR=`echo $SMASHED_LINE | cut -f 2 -d ' '`
    DEV=`echo $SMASHED_LINE | cut -f 4 -d ' '`
    if [ ! -b /dev/$DEV ]; then
      mknod -m 660 /dev/$DEV b $MAJOR $MINOR
      chown root.disk /dev/$DEV 2>$TMP/null
    fi
  done
 fi
 rm -f $TMP/null
